#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	ofBackground(100,225,155);
	
	frameByframe = false;

	pandaMovie.loadMovie("movies/panda.mp4");
	pandaMovie.play();
}

//--------------------------------------------------------------
void testApp::update(){
    pandaMovie.idleMovie();
}

//--------------------------------------------------------------
void testApp::draw(){

	ofSetColor(0xFFFFFF);




    pandaMovie.draw(20,20);
    ofSetColor(0x6600CC);
    unsigned char * pixels = pandaMovie.getPixels();
    // let's move through the "RGB" char array
    // using the red pixel to control the size of a circle.
    for (int i = 4; i < 400; i+=8){
        for (int j = 4; j < 300; j+=8){
            unsigned char r = pixels[(j * 400 + i)*3];
            float val = 1 - ((float)r / 255.0f);
			ofEllipse(425 + i,25+j,20,10*val);
			//ofCircle(<#float x#>, <#float y#>, <#float radius#>)
			//ofCircle(425 + i,20+j,7*val); //425 is what moved pixelated image
        }
    }


    ofSetColor(0x00000); //0xFFCC33
	ofDrawBitmapString("press x to change",20,340); // 20,320
    if(frameByframe) ofSetColor(0xCCCCCC);
	ofSetColor(0x000000); //0x000000
    ofDrawBitmapString("mouse speed position",20,360); //20,340
    if(!frameByframe) ofSetColor(0x000000); else ofSetColor(0x000000);
    ofDrawBitmapString("keys <- -> frame by frame " ,190,360); //,190,360 <-- last thing i worked on
    ofSetColor(0x000000);

    ofDrawBitmapString("frame: " + ofToString(pandaMovie.getCurrentFrame()) + "/"+ofToString(pandaMovie.getTotalNumFrames()),20,380); //20,380
    ofDrawBitmapString("duration: " + ofToString(pandaMovie.getPosition()*pandaMovie.getDuration(),2) + "/"+ofToString(pandaMovie.getDuration(),2),20,400);
    ofDrawBitmapString("speed: " + ofToString(pandaMovie.getSpeed(),2),20,420); //,2),20,420

    if(pandaMovie.getIsMovieDone()){
        ofSetColor(0xFF0000); //0xFF0000
        ofDrawBitmapString("end of movie",20,440);
    }
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){
    switch(key){
        case 'x': //'f'
            frameByframe=!frameByframe;
            pandaMovie.setPaused(frameByframe);
        break;
        case OF_KEY_LEFT:
            pandaMovie.previousFrame();
        break;
        case OF_KEY_RIGHT:
            pandaMovie.nextFrame();
        break;
        case '0':
            pandaMovie.firstFrame();
        break;
    }
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	if(!frameByframe){
        int width = ofGetWidth();
        float pct = (float)x / (float)width;
        float speed = (2 * pct - 1) * 5.0f;
        pandaMovie.setSpeed(speed);
	}
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	if(!frameByframe){
        int width = ofGetWidth();
        float pct = (float)x / (float)width;
        pandaMovie.setPosition(pct);
	}
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	if(!frameByframe){
        pandaMovie.setPaused(true);
	}
}


//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
	if(!frameByframe){
        pandaMovie.setPaused(false);
	}
}

//--------------------------------------------------------------
void testApp::resized(int w, int h){

}
